<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="日报id" prop="reportId">
        <el-input v-model="formData.reportId" placeholder="请输入日报id" />
      </el-form-item>
      <el-form-item label="施工队伍id" prop="deptId">
        <el-input v-model="formData.deptId" placeholder="请输入施工队伍id" />
      </el-form-item>
      <el-form-item label="项目id" prop="projectId">
        <el-input v-model="formData.projectId" placeholder="请输入项目id" />
      </el-form-item>
      <el-form-item label="任务id" prop="taskId">
        <el-input v-model="formData.taskId" placeholder="请输入任务id" />
      </el-form-item>
      <el-form-item label="项目类别(钻井 修井 注氮 酸化压裂... )" prop="projectClassification">
        <el-input v-model="formData.projectClassification" placeholder="请输入项目类别(钻井 修井 注氮 酸化压裂... )" />
      </el-form-item>
      <el-form-item label="施工工艺" prop="technique">
        <el-input v-model="formData.technique" placeholder="请输入施工工艺" />
      </el-form-item>
      <el-form-item label="工作量属性标识符(bridgePlug waterVolume...)" prop="reportAttrIdentifier">
        <el-input v-model="formData.reportAttrIdentifier" placeholder="请输入工作量属性标识符(bridgePlug waterVolume...)" />
      </el-form-item>
      <el-form-item label="工作量属性名称(泵车台次 仪表/混砂...)" prop="reportAttrName">
        <el-input v-model="formData.reportAttrName" placeholder="请输入工作量属性名称(泵车台次 仪表/混砂...)" />
      </el-form-item>
      <el-form-item label="工作量属性值" prop="reportAttrValue">
        <el-input v-model="formData.reportAttrValue" placeholder="请输入工作量属性值" />
      </el-form-item>
      <el-form-item label="排序值" prop="sort">
        <el-input v-model="formData.sort" placeholder="请输入排序值" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="状态(0启用 1禁用)" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio value="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotRdDailyReportItemApi, IotRdDailyReportItemVO } from '@/api/pms/iotrddailyreportitem'

/** 瑞都日报 (工作量)明细 表单 */
defineOptions({ name: 'IotRdDailyReportItemForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  reportId: undefined,
  deptId: undefined,
  projectId: undefined,
  taskId: undefined,
  projectClassification: undefined,
  technique: undefined,
  reportAttrIdentifier: undefined,
  reportAttrName: undefined,
  reportAttrValue: undefined,
  sort: undefined,
  remark: undefined,
  status: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotRdDailyReportItemApi.getIotRdDailyReportItem(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotRdDailyReportItemVO
    if (formType.value === 'create') {
      await IotRdDailyReportItemApi.createIotRdDailyReportItem(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotRdDailyReportItemApi.updateIotRdDailyReportItem(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    reportId: undefined,
    deptId: undefined,
    projectId: undefined,
    taskId: undefined,
    projectClassification: undefined,
    technique: undefined,
    reportAttrIdentifier: undefined,
    reportAttrName: undefined,
    reportAttrValue: undefined,
    sort: undefined,
    remark: undefined,
    status: undefined,
  }
  formRef.value?.resetFields()
}
</script>